/*
 * Copyright 2005-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jatva.lang;

import jatva.util.Utils;

public class IncorrectMediatorObjectException
  extends CriticalRuntimeTestException
{
  public IncorrectMediatorObjectException (String p_class, ModelObject obj, String[] names, Object[] fields)
  {
    super(  "Incorrect mediator object found for the implementation references"
          , prepareTags(names)
          , prepareValues(p_class, obj, fields)
         );
  }
  
  private static String[] prepareTags(String[] names)
  {
    String[] res = new String[names.length + 2];
    res[0] = "mediator class";
    res[1] = "object found";
    
    for(int i = 0; i < names.length; i++)
      res[i + 2] = names[i];
    
    return res;
  }
  
  private static String[] prepareValues(String p_class, ModelObject o, Object[] fields)
  {
    String[] res = new String[fields.length + 2];
    res[0] = p_class;
    res[1] = Utils.getSimpleString(o);
    
    for(int i = 0; i < fields.length; i++)
      res[i + 2] = Utils.getSimpleString(fields[i]);
    
    return res;
  }
}
