/*
 * Copyright 2005-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jatva.lang;

import jatva.lang.synchronization.SynchronizationObjectInterface;

/**
 * @author <a href="mailto:monakhov@ispras.ru">Alexander Monakhov</a>
 */
public class ModelEventProperties
{
    private SynchronizationObjectInterface synchronizationObject;
    private Object channelID;

    public static final
        ModelEventProperties Empty = new ModelEventProperties( null, null );

    /**
     * will be used to set the current channel id to the current registrar
     * see TestManager.registerModelEvent
     */
    public static final Object defaultChannelId = new Object();

    public ModelEventProperties
        ( SynchronizationObjectInterface synchronizationObject )
    { this( synchronizationObject, null ); }

    public ModelEventProperties
        ( SynchronizationObjectInterface synchronizationObject
        , Object channelID
        )
    {
        this.synchronizationObject = synchronizationObject;
        this.channelID = channelID;
    }

    public SynchronizationObjectInterface getSynchronizationObject()
    {
        return synchronizationObject;
    }

    public Object getChannelID()
    {
        return channelID;
    }
}
