/*
 * Copyright 2005-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jatva.lang.synchronization;

import com.unitesk.jogs.Snapshot;

/**
 * Empty serializer doesn't call any oracles or model state updates
 * and thus accepts any observed behavior.
 *
 * One may need this serializer if using JavaTESK to develope tests
 * in the style of separate test cases. for test cases.
 *
 * @author <a href="mailto:monakhov@ispras.ru">Alexander Monakhov</a>
 */
public final class EmptySerializer extends AbstractSerializer
{
    public static final EmptySerializer prototype = new EmptySerializer();

    private EmptySerializer(){}

    @Override
    protected SerializationResult serialize( Snapshot testStateBeforeFrameSnapshot )
    { return SerializationResult.OK; }

    @Override
    public AbstractSerializer clone()
    { return prototype; }
}
