/*
 * Copyright 2005-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jatva.tracer.messages;

import jatva.lang.synchronization.TestManager;

public class ImplementationResultMessage extends TracerMessage
{
    private String staticResultType;
    private Object result;

    public ImplementationResultMessage( TestManager registrar
                                      , String staticResultType
                                      , Object result
                                      )
    {
        super( registrar );
        this.staticResultType = staticResultType;
        this.result = result;
    }

    @Override
    protected StringBuffer format()
    { return tracer.formatImplementationResult( registrar, staticResultType, result ); }
}
