/*
 * Copyright 2005-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jatva.util;

import jatva.iterators.lang.IObjectIterator;

/**
 * @author Administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public interface IMultiSet extends Cloneable
{
  int size();

  /* (non-Javadoc)
   * @see java.util.Collection#clear()
   */
  void clear();

  /* (non-Javadoc)
   * @see java.util.Collection#isEmpty()
   */
  boolean isEmpty();

  /* (non-Javadoc)
   * @see java.util.Collection#toArray()
   */
  Object[] toArray();

  /* (non-Javadoc)
   * @see java.util.Collection#add(java.lang.Object)
   */
  boolean add(Object arg0);
  
  boolean add(Object o, int n);
  
  int count(Object o);

  /* (non-Javadoc)
   * @see java.util.Collection#contains(java.lang.Object)
   */
  boolean contains(Object arg0);

  boolean containsRef(Object o);
  
  /* (non-Javadoc)
   * @see java.util.Collection#remove(java.lang.Object)
   */
  boolean remove(Object arg0);
  
  boolean remove(Object o, int n); 

  boolean replace(Object o1, Object o2);
  
  boolean replace(Object o1, Object o2, int n);
  
  /* (non-Javadoc)
   * @see java.util.Collection#addAll(java.util.Collection)
   */
  boolean addAll(IMultiSet arg0);

  /* (non-Javadoc)
   * @see java.util.Collection#containsAll(java.util.Collection)
   */
  boolean containsAll(IMultiSet arg0);

  boolean containsAll(ISet arg0);

  /* (non-Javadoc)
   * @see java.util.Collection#removeAll(java.util.Collection)
   */
  boolean removeAll(IMultiSet arg0);

  /* (non-Javadoc)
   * @see java.util.Collection#retainAll(java.util.Collection)
   */
  boolean retainAll(IMultiSet arg0);

  /* (non-Javadoc)
   * @see java.util.Collection#iterator()
   */
  IObjectIterator iterator();

  IList toList();

  ISet toSet();  

  Object clone();
  
  String toString();
  
  boolean equals(Object o);
  
  boolean equalsByElementsRefs(Object o);
  
  int hashCode();
}
